package date_20250513;

import org.apache.kafka.clients.consumer.*;
import org.apache.kafka.common.serialization.IntegerDeserializer;
import org.apache.kafka.common.serialization.StringDeserializer;

import java.time.Duration;
import java.util.Arrays;
import java.util.Properties;


/**
 * 消费者类
 */

public class MyConsumer {

    public static void main(String[] args) {
        //1.使用Proerties定义配置属性
        Properties props = new Properties();
        //设置生产者Broker服务器连接地址
        props.setProperty(ConsumerConfig.BOOTSTRAP_SERVERS_CONFIG, "hadoop102:9092");
        //设置序列化key程序类
        props.setProperty(ConsumerConfig.KEY_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class.getName());
        //设置序列号化value程序类，此处不一定是非得时Integer，也可以是String
        props.setProperty(ConsumerConfig.VALUE_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class.getName());
        //设置消费者组ID，即组名称，值可自定义，组名称相同的消费者进程属于用一个消费者
        props.setProperty(ConsumerConfig.GROUP_ID_CONFIG, "test-consumer-group4");
        // 设置从头开始消费
        props.put("auto.offset.reset", "earliest");
        //2.定义消费者对象
        Consumer<String, String> consumer = new KafkaConsumer<String, String>(props);
        //3.设置消费者读取的主题名称，可以设置多个
        consumer.subscribe(Arrays.asList("topic02"));
        //4.不同的读取消息
        while (true) {
            System.out.println("打印开始");
            //拉取消息，并设置超时时间为10秒
            ConsumerRecords<String, String> records = consumer.poll(Duration.ofSeconds(100));
            for (ConsumerRecord<String, String> record : records) {
                System.out.println(record.value() + ", " + record.partition() + ",offset: " + record.offset());

            }
        }

    }
}
